﻿using System;
using System.Threading;

namespace Lock
{
    class Account { 
        private Object thisLock = new Object(); 
        int balance; 
        Random r = new Random(); 
        public Account(int initial) { balance = initial; }
        int Withdraw(int amount)
        { // Ovo se nece dogoditi ako je lock aktivan
            if (balance < 0)
            {
                throw new Exception("Negativno stanje");
            } 
            // Komentirajte sljedecu liniju 
            lock (thisLock)
            {
                if (balance >= amount)
                {
                    Console.WriteLine("Stanje prije : " + balance);
                    Console.WriteLine("Iznos koji se podize : -" + amount);
                    balance = balance - amount;
                    Console.WriteLine("Stanje nakon : " + balance);
                    return amount;
                }
                else
                {
                    return 0; // transakcija odbijena
                }
            }
        }
        public void DoTransactions() { 
            for (int i = 0; i < 100; i++) { 
                Withdraw(r.Next(1, 100)); 
            } 
        } 
    } 
    
    class Program { 
        static void Main() { 
            Thread[] threads = new Thread[10]; 
            Account acc = new Account(1000); // zajednicki objekt za sve threadove
            for (int i = 0; i < 10; i++) 
                threads[i] = new Thread(new ThreadStart(acc.DoTransactions));
            for (int i = 0; i < 10; i++) threads[i].Start();
            for (int i = 0; i < 10; ++i) threads[i].Join();
            Console.ReadKey();
        }
    }
}
