﻿using System;
using System.Threading; 

public sealed class App { 
    static WaitHandle[] waitHandles = new WaitHandle[] { new AutoResetEvent(false), new AutoResetEvent(false) };
    static Random r = new Random();

    static void DoTask(Object state)
    {
        AutoResetEvent are = (AutoResetEvent)state;
        int time = 1000 * r.Next(2, 10);
        Console.WriteLine("Zapoceo posao od {0} milisekundi.", time);
        Thread.Sleep(time); are.Set();
    }

    static void Main() { 
        DateTime dt = DateTime.Now; 

        Console.WriteLine("Glavni thread ceka da OBA threada zavrse posao.");
        ThreadPool.QueueUserWorkItem(new WaitCallback(DoTask), waitHandles[0]);
        ThreadPool.QueueUserWorkItem(new WaitCallback(DoTask), waitHandles[1]);
        WaitHandle.WaitAll(waitHandles); // Vrijeme najduzeg posla.
        Console.WriteLine("Oba threada su zavrsila (time waited={0})", (DateTime.Now - dt).TotalMilliseconds); 

        dt = DateTime.Now; 
        Console.WriteLine();
        Console.WriteLine("Glavni thread ceka da bilo koji thread zavrsi posao."); 
        ThreadPool.QueueUserWorkItem(new WaitCallback(DoTask), waitHandles[0]); 
        ThreadPool.QueueUserWorkItem(new WaitCallback(DoTask), waitHandles[1]); 
        int index = WaitHandle.WaitAny(waitHandles); // Vrijeme najkraceg posla, rezultat je indeks handlea
        Console.WriteLine("Thread {0} je zavrsio (time waited={1}).", index + 1, (DateTime.Now - dt).TotalMilliseconds);
    } 
}